﻿<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Local Registry Provider EN</title>
  <link rel="stylesheet" href="https://stackedit.io/style.css" />
</head>

<body class="stackedit">
  <div class="stackedit__html"><h1 id="lfusion-local-registry-provider">LFusion Local Registry Provider</h1>
<p>This package is used to create a registry provider linked to the project.<br>
Packages can be added by extensions implementing a provider.</p>
<ol>
<li><a href="#prerequisites">Prerequisites</a></li>
<li><a href="#installation">Installation</a></li>
<li><a href="#configuration">Configuration</a></li>
<li><a href="#safe-mode">Safe Mode</a></li>
<li><a href="#lfusion-extensions">LFusion Extensions</a></li>
</ol>
<h2 id="prerequisites">Prerequisites</h2>
<ul>
<li><strong>Unity 2020</strong> or higher</li>
</ul>
<h2 id="installation">Installation</h2>
<h3 id="install-via-gitlab-registry">Install via Gitlab registry</h3>
<ul>
<li>Add the <a href="https://gitlab.com/lfusion/upm-registry">LFusion Upm-Registry</a></li>
<li><strong>For Unity 2021 or highter</strong>
<ul>
<li>Package Manager</li>
<li><strong>+</strong> Add package by name…
<ul>
<li><code>Name : com.lfusion.localregistryprovider.core</code></li>
</ul>
</li>
</ul>
</li>
<li><strong>For all supported Unity versions</strong>
<ul>
<li>Open <code>manifest.json</code> in the Packages folder of the project.</li>
<li>Add <code>"com.lfusion.localregistryprovider.core": "x.x.x",</code> to the <code>dependencies</code> block, replacing <code>x.x.x</code> with the desired version.</li>
<li>Example for version <code>1.0.0</code> :</li>
</ul>
</li>
</ul>
<pre class=" language-json"><code class="prism  language-json"><span class="token punctuation">{</span>
  <span class="token string">"dependencies"</span><span class="token punctuation">:</span> <span class="token punctuation">{</span>
    <span class="token string">"com.lfusion.localregistryprovider.core"</span><span class="token punctuation">:</span> <span class="token string">"1.0.0"</span><span class="token punctuation">,</span>
    <span class="token punctuation">[</span><span class="token operator">...</span><span class="token punctuation">]</span>
  <span class="token punctuation">}</span><span class="token punctuation">,</span>
  <span class="token punctuation">[</span><span class="token operator">...</span><span class="token punctuation">]</span>
<span class="token punctuation">}</span>
</code></pre>
<h3 id="install-via-tarball">Install via tarball</h3>
<ul>
<li>Download <code>com.lfusion.localregistryprovider.core-x.x.x.tgz</code> from <a href="https://gitlab.com/lfusion/localregistryprovider/core/-/releases">releases</a>.</li>
<li>Package Manager</li>
<li><strong>+</strong> Add package from tarball…</li>
<li>Select  <code>com.lfusion.localregistryprovider.core-x.x.x.tgz</code></li>
</ul>
<h2 id="configuration">Configuration</h2>
<p>LFusion Local Registry Provider settings can be accessed from:</p>
<ol>
<li><code>Edit/Project Settings...</code></li>
<li><code>Package Manager/Local Registry</code></li>
</ol>
<h3 id="package-mode">Package Mode</h3>
<p>Indicates the package delivery mode, <em>Disembedded</em> (local server) or <em>Embedded</em>.<br>
Switches package delivery mode.</p>
<ul>
<li><em>Disembedded</em> mode is used to install new packages.</li>
<li><em>Embedded</em> mode transfers packages to the project.<br>
<strong>↳</strong> Switch to this mode before committing the project with a versioning tool.</li>
</ul>
<h3 id="general">General</h3>

<table>
<thead>
<tr>
<th>Name</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td>Provider Port</td>
<td>Defines the port used by the registry server</td>
</tr>
<tr>
<td>Auto Update Registry</td>
<td>Enables automatic updating of the scoped registry</td>
</tr>
<tr>
<td>Scope Accuracy</td>
<td>Defines the depth of automatically created scopes</td>
</tr>
</tbody>
</table><h3 id="providers">Providers</h3>
<p>This section lists the extensions and the packages they provide.<br>
Providers can be added by implementing <code>IProvider</code>.</p>
<h3 id="rules">Rules</h3>
<p>This section allows you to add rules for modifying package information on the fly.<br>
A rule is made up of filter(s) and action(s).<br>
Filters and actions can be added by implementing <code>IFilter</code> and <code>IAction</code> respectively.</p>
<h3 id="advanced-settings">Advanced Settings</h3>

<table>
<thead>
<tr>
<th>Nom</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Standalone Server</strong></td>
<td>Allows you to manage a project that can be used as an independent server</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Create</em></td>
<td>Create the project in the StandaloneRegistryServer subfolder</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Clean</em></td>
<td>Cleans up the project in the StandaloneRegistryServer subfolder</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Delete</em></td>
<td>Deletes the project from the StandaloneRegistryServer subfolder</td>
</tr>
<tr>
<td><strong>Clear Cache</strong></td>
<td>Allows you to clean package caches</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Unity</em></td>
<td>Clean cache <a href="https://docs.unity3d.com/Manual/upm-cache.html">Global</a> &amp; Project</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Local Server</em></td>
<td>Clean providers cache</td>
</tr>
<tr>
<td><strong>↳</strong> <em>Both</em></td>
<td>Clean the two caches above</td>
</tr>
<tr>
<td><strong>↳</strong> <em>□ Save force sync</em></td>
<td>Saves cache clean-up to be passed on to other developers</td>
</tr>
<tr>
<td>Debug Mode</td>
<td>Activate full logs and add information to packages</td>
</tr>
</tbody>
</table><h2 id="safe-mode">Safe Mode</h2>
<p>If Unity starts up in safe mode, the provider server will not be able to launch. To do this, you can launch the extension within a dedicated project.</p>
<ol>
<li>You can create this project using the <code>Create</code> button in the <code>Advanced Settings</code> of <strong>LFusion Local Registry Provider</strong>.</li>
<li>You can also create it manually.
<ul>
<li>Copy the Packages and ProjectSettings folders from the project into a new folder.</li>
<li>Create a new empty <code>Assets</code> folder in the previously created folder.</li>
</ul>
</li>
</ol>
<h2 id="lfusion-extensions">LFusion Extensions</h2>

<table>
<thead>
<tr>
<th>Name</th>
<th>Package Name</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td>Tgz Provider</td>
<td>com.lfusion.localregistryprovider.tgzprovider</td>
<td>Reference local or online packages. Its <code>ITgzProvider</code> class simplifies the development of extensions.</td>
</tr>
<tr>
<td>Google Provider</td>
<td>com.lfusion.localregistryprovider.googleprovider</td>
<td>Reference Google packages hosted on: <a href="https://developers.google.com/unity/archive">https://developers.google.com/unity/archive</a> and Github.</td>
</tr>
<tr>
<td><s>Unity Package Provider</s></td>
<td><s>com.lfusion.localregistryprovider.xxxx</s></td>
<td><s>Convert and reference packages from .unitypackages</s></td>
</tr>
</tbody>
</table></div>
</body>

</html>
